package com.alihealth.d2d.provtest.controller;

import com.alihealth.d2d.provtest.VO.DrugRetraceVO;
import com.alihealth.d2d.provtest.common.AjaxResult;
import com.alihealth.d2d.provtest.searcher.DrugRetraceSearcher;
import com.alihealth.d2d.provtest.service.DrugRetraceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 药品流程追溯控制器
 */
@RestController
@RequestMapping("/drugRetrace")
public class DrugRetraceController {

    @Autowired
    private DrugRetraceService drugRetraceService;

    @PostMapping(value = "/retrace")
    public AjaxResult retrace(@RequestBody DrugRetraceSearcher searcher) {
        try {
            DrugRetraceVO drugRetraceVO = drugRetraceService.retrace(searcher);
            return AjaxResult.success(drugRetraceVO);
        } catch (Exception e) {
            return AjaxResult.error(e.getMessage());
        }
    }
}
