package com.alihealth.d2d.provtest.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 境外药品生产企业基本信息数据子集
 * </p>
 *
 * @author Jason
 * @since 2025-06-06
 */
@Data
@TableName("abroad_pharma_base_info")
public class AbroadPharmaBaseInfo implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 事件流水号
     */
    private String eventId;

    /**
     * 境外药品生产企业代码
     */
    @JacksonXmlProperty(localName = "JWYPSCQYDM")
    private String jwypscqydm;

    /**
     * 境外药品生产企业名称（中文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYMCZW")
    private String jwypscqymczw;

    /**
     * 境外药品生产企业名称（英文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYMCYW")
    private String jwypscqymcyw;

    /**
     * 境外药品生产企业地址（中文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYDZZW")
    private String jwypscqydzzw;

    /**
     * 境外药品生产企业地址（英文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYDZYW")
    private String jwypscqydzyw;

    /**
     * 境外药品生产企业国家（或地区）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYGJHDQ")
    private String jwypscqygjhdq;

    /**
     * 境外药品生产企业国家或地区（中文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYGJHDQZW")
    private String jwypscqygjhdqzw;

    /**
     * 境外药品生产企业国家或地区（英文）
     */
    @JacksonXmlProperty(localName = "JWYPSCQYGJHDQYW")
    private String jwypscqygjhdqyw;

    /**
     * 固定电话号码
     */
    @JacksonXmlProperty(localName = "GDDHHM")
    private String gddhhm;

    /**
     * 传真号码
     */
    @JacksonXmlProperty(localName = "CZHM")
    private String czhm;

    /**
     * 电子信箱
     */
    @JacksonXmlProperty(localName = "DZXX")
    private String dzxx;

    /**
     * 企业网址
     */
    @JacksonXmlProperty(localName = "QYWZ")
    private String qywz;

    /**
     * 联系人
     */
    @JacksonXmlProperty(localName = "LXR")
    private String lxr;

    /**
     * 联系电话
     */
    @JacksonXmlProperty(localName = "LXDH")
    private String lxdh;

    /**
     * 创建时间
     */
    private LocalDateTime createTime;

    /**
     * 更新时间
     */
    private LocalDateTime updateTime;

    /**
     * 是否删除(0-否 1-是)
     */
    private Integer isDeleted;


}
