package com.alihealth.d2d.provtest.service.handle.business;

import com.alihealth.d2d.provtest.domain.DrugSelfInspectionApplyInfo;
import com.alihealth.d2d.provtest.entity.EventBasic;
import com.alihealth.d2d.provtest.entity.EventBody;
import com.alihealth.d2d.provtest.entity.InstanceDetail;
import com.alihealth.d2d.provtest.entity.ItemDetail;
import com.alihealth.d2d.provtest.service.IDrugSelfInspectionApplyInfoService;
import com.alihealth.d2d.provtest.service.handle.AbstractEventDataHandler;
import com.alihealth.d2d.provtest.service.handle.EventSubType;
import com.baomidou.mybatisplus.extension.service.IService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;

/**
 * @author Jason
 * @date 2025年06月05日 11:37:52
 */
@EventSubType("2013")
@Service
public class SubType2013Handler extends AbstractEventDataHandler<DrugSelfInspectionApplyInfo> {

    @Autowired
    private IDrugSelfInspectionApplyInfoService service;

    @Override
    protected Class<DrugSelfInspectionApplyInfo> getEntityClass() {
        return DrugSelfInspectionApplyInfo.class;
    }

    @Override
    protected IService<DrugSelfInspectionApplyInfo> getService() {
        return service;
    }

    @Override
    protected DrugSelfInspectionApplyInfo convertToEntity(EventBody eventBody, ItemDetail item, InstanceDetail instance,String eventId) {
        EventBasic evtBasic = eventBody.getEvtBasic();
        //时间格式
        SimpleDateFormat formatterDatetime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        //日期格式
        SimpleDateFormat formatterDate = new SimpleDateFormat("yyyyMMdd");
        try {
            return DrugSelfInspectionApplyInfo.builder()
                    .eventId(eventId)
                    .recTime(formatterDatetime.parse(eventBody.getRecTime()))

                    .ypjybgsbh(evtBasic.getString("YPJYBGSBH"))
                    .ymjyrq(formatterDate.parse(evtBasic.getString("YMJYRQ")))
                    .ypjybgsmj(evtBasic.getString("YPJYBGSMJ"))

                    .gjypbsm(item.getString("GJYPBSM"))
                    .gjjbywbs(item.getString("GJJBYWBS"))
                    .yptymc(item.getString("YPTYMC"))
                    .ypywmc(item.getString("YPYWMC"))
                    .jkypzwym(item.getString("JKYPZWYM"))
                    .jkyppjh(item.getString("JKYPPJH"))
                    .jkyppjyxq(formatterDate.parse(item.getString("JKYPPJYXQ")))
                    .ypspmc(item.getString("YPSPMC"))
                    .ypbwm(item.getString("YPBWM"))
                    .jx(item.getString("JX"))
                    .zjgg(item.getString("ZJGG"))
                    .bzgg(item.getString("BZGG"))
                    .bzzhb(Integer.parseInt(item.getString("BZZHB")))
                    .ypyxq(item.getInt("YPYXQ"))
                    .ypyxqdw(item.getString("YPYXQDW"))
                    .yppzwh(item.getString("YPPZWH"))
                    .yppzwhyxq(formatterDate.parse(item.getString("YPPZWHYXQ")))
                    .jkypzczh(item.getString("JKYPZCZH"))
                    .jkypzczyxq(formatterDate.parse(item.getString("JKYPZCZYXQ")))
                    .ypzcfl(item.getString("YPZCFL"))
                    .gjjbywbs(item.getString("GJJBYWBS"))
                    .tsypglfl(item.getString("TSYPGLFL"))
                    .cfybs(item.getString("CFYBS"))
                    .jnypssxkcyrmc(item.getString("JNYPSSXKCYRMC"))
                    .tyshxydmjnypssxkcyr(item.getString("TYSHXYDMJNYPSSXKCYR"))
                    .jwypssxkcyrmczw(item.getString("JWYPSSXKCYRMCZW"))
                    .jwypssxkcyrmcyw(item.getString("JWYPSSXKCYRMCYW"))
                    .jwypssxkcyrdm(item.getString("JWYPSSXKCYRDM"))
                    .jnypscqymc(item.getString("JNYPSCQYMC"))
                    .tyshxydmjnypscqy(item.getString("TYSHXYDMJNYPSCQY"))
                    .jwypscqymczw(item.getString("JWYPSCQYMCZW"))
                    .jwypscqymcyw(item.getString("JWYPSCQYMCYW"))
                    .jwypscqydm(item.getString("JWYPSCQYDM"))
                    .fbzcmc(item.getString("FBZCMC"))
                    .tyshxydmfbzc(item.getString("TYSHXYDMFBZC"))
                    .ypscrq(formatterDate.parse(item.getString("YPSCRQ")))
//                    .ypyxqjzrq(formatterDate.parse(item.getString("YPYXQJZRQ"))) //值为暂无不保存
                    .ypscph(item.getString("YPSCPH"))
                    .bgrq(formatterDate.parse(item.getString("BGRQ")))
                    .gzrq(formatterDatetime.parse(item.getString("GZRQ")))
                    .build();
        } catch (ParseException e) {
            throw new RuntimeException(e);
        }
    }

    @Override
    public String getSubType() {
        return "2013";
    }

    @Override
    public void handleBase(String xml, String eventId) {

    }
}
