package com.alihealth.d2d.provtest.service.impl;

import com.alihealth.d2d.provtest.domain.ReceiveDataLog;
import com.alihealth.d2d.provtest.mapper.ReceiveDataLogMapper;
import com.alihealth.d2d.provtest.searcher.DrugResolveSearcher;
import com.alihealth.d2d.provtest.service.IReceiveDataLogService;
import com.alihealth.d2d.provtest.utils.CertManager;
import com.alihealth.d2d.provtest.utils.StreamUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.crypto.BadPaddingException;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import java.io.IOException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

/**
 * @author Jason
 * @date 2025年06月03日 15:37:17
 */
@Service("receiveDataLogService")
public class ReceiveDataLogServiceImpl extends ServiceImpl<ReceiveDataLogMapper, ReceiveDataLog> implements IReceiveDataLogService {
    Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private ReceiveDataLogMapper receiveDataLogMapper;

    @Autowired
    private CertManager certManager;

    @Override
    public void resolve(DrugResolveSearcher searcher) throws NoSuchPaddingException, IllegalBlockSizeException, NoSuchAlgorithmException, InvalidKeySpecException, BadPaddingException, IOException, InvalidKeyException {
      ReceiveDataLog receiveDataLog =  receiveDataLogMapper.selectOne(
                new QueryWrapper<ReceiveDataLog>().lambda()
                        .eq(ReceiveDataLog::getEventId, searcher.getEventId())
        );
        String data = receiveDataLog.getData();
        String privateKey = certManager.getPrivateKey();
        String de = certManager.testDecrypt(privateKey, data);
        String xml = StreamUtil.getUnStreamContent(de);
        logger.info("解密之后的文件内容:{}", xml);

    }
}
